using System;
using System.Collections.Generic;
using System.Text;

using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace Winsmarts.OPMLEditor
{
    public class OPMLEditor : EditorPart
    {
        private TextBox opmlCSV;

        public OPMLEditor()
        {
            this.ID = "MyEditorPart";
        }

        protected override void CreateChildControls()
        {
            opmlCSV = new TextBox();
            opmlCSV.TextMode = TextBoxMode.MultiLine;
            opmlCSV.Width = new Unit("300px");
            opmlCSV.Height = new Unit("100px");
            Controls.Add(opmlCSV);
        }

        public override bool ApplyChanges()
        {
            EnsureChildControls();
            UIWebPart part = WebPartToEdit as UIWebPart;
            if (part != null)
            {
                List<String> feeds = new List<String>() ;
                string[] rssfeeds = opmlCSV.Text.Split(',');
                foreach (string rssfeed in rssfeeds)
                {
                    feeds.Add(rssfeed.Trim()) ;                    
                }
                part.FeedURLS = feeds;
            }
            else
            {
                return false;
            }
            return true;
        }

        public override void SyncChanges()
        {
            EnsureChildControls();
            UIWebPart part = WebPartToEdit as UIWebPart;
            if (part != null)
            {
                StringBuilder sb = new StringBuilder();
                foreach (String rssFeed in part.FeedURLS)
                {
                    sb.Append(rssFeed) ;
                    sb.Append(",") ;
                }
                if (part.FeedURLS.Count != 0)
                    sb.Remove(sb.Length-1,1) ;

                opmlCSV.Text = sb.ToString();
            }
        }
    }
}
