using System;
using System.Collections.Generic;
using System.Text;

using System.Web;
using System.Web.UI;

using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace Winsmarts.OPMLEditor
{
    public class UIWebPart : WebPart, IWebEditable
    {
        private List<String> feedURLs = new List<String>();
        private RadioButtonList rbl; 

        [Personalizable(PersonalizationScope.Shared)]
        public List<String> FeedURLS
        {
            get { return feedURLs; }
            set { feedURLs = value; }
        }

        protected override void CreateChildControls()
        {
            rbl = new RadioButtonList();

            foreach (string rssFeed in feedURLs)
            {
                rbl.Items.Add(new ListItem(rssFeed));
            }

            rbl.AutoPostBack = true ;
            this.Controls.Add(rbl);
        }

        // Editor code

        #region IWebEditable Members

        EditorPartCollection IWebEditable.CreateEditorParts()
        {
            List<EditorPart> editors = new List<EditorPart>();
            editors.Add(new OPMLEditor());
            return new EditorPartCollection(editors);
        }

        object IWebEditable.WebBrowsableObject
        {
            get { return this; }
        }

        #endregion

        //Communication code

        private IRssFeedContract theProvider ;

        [ConnectionConsumer("Rss service Consumer")]
        public void InitializeProvider(IRssFeedContract provider)
        {
            theProvider = provider ;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

            if (theProvider != null)
            {
                theProvider.RSSUrl = rbl.SelectedValue ;
            }
        }
    }
}